<?php

/**
 * Description of dashaApi
 *
 * @author ors
 */
class dashaApi {

    public $username;
    public $password;
    public $lang = 'ru';
    private $langlist = array('ru', 'en');

    /**
     * Создаем объект с разрешенными языками
     * @param string $key ключ доступа к API
     * @param string $lang язык сообщений сервера API, в данный момент поддерживается ru, en, it
     */
    public function __construct($username, $password, $lang = 'ru') {
	$this->username = $username;
	$this->password = $password;
	if (in_array($lang, $this->langlist))
	    $this->lang = $lang;
    }

    /**
     * Отправка запросов и обработка ошибок
     * @param string $method название метода
     * @param array $args аргументы метода, свои для каждого метода
     */
    private function dashaRequest($method, $args) {

	$post_array = array_merge(array(
	    'username' => $this->username,
	    'password' => $this->password
	),$args);

	$ch = curl_init();
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
	curl_setopt($ch, CURLOPT_POST, 1);
	curl_setopt($ch, CURLOPT_POSTFIELDS, $post_array);
	curl_setopt($ch, CURLOPT_TIMEOUT, 1);
	curl_setopt($ch, CURLOPT_URL,
		'https://api.dashamail.com/?method='.$method.'&format=json' );
	$result = curl_exec($ch);

	if ($result) {
	    // Раскодируем ответ API-сервера
	    $jsonObj = json_decode($result);

	    if (null === $jsonObj) {
		// Ошибка в полученном ответе
		echo "Invalid JSON";
	    } elseif ($jsonObj->response->msg->err_code) {
		// Ошибка добавления пользователя
		echo "An error occured: " . $jsonObj->response->msg->text . "(code: " . $jsonObj->response->msg->err_code . ")";
	    }
	} else {
	    // Ошибка соединения с API-сервером
	    echo "API access error";
	}
	return $jsonObj->response->data;
    }
/**
 * Этот метод добавляет контакты (e-mail адрес и/или мобильный телефон) подписчика в один или несколько списков, а также позволяет добавить/поменять значения дополнительных полей и меток.
 * @param <type> $email
 * @param <type> $list Перечисленные через запятую коды списков, в которые надо добавить подписчика.
 * @param <type> $phone В случае наличия и e-mail, и телефона, подписчик будет включён и в e-mail, и в SMS списки рассылки.
 * @param <type> $ip IP-адрес подписчика
 * @param <type> $first_name
 * @param <type> $last_name 
 */
/* 
    public function subscribe($email, $list, $phone=NULL, $ip=NULL, $first_name=NULL, $last_name=NULL) {
	$args = array (
	  'list_ids' => $list,
	  'fields[email]' => $email,
	  'fields[Name]' => $first_name.' '.$last_name,
	  'request_ip' => $ip,
	  'overwrite' => 2,
	  'request_time' => date("Y.m.d"),
	  'confirm_time' => date("Y.m.d"),
	  'double_optin' => 1
	);
	if ($phone)
	    $args['fields[phone]']=$phone;
	$result=$this->dashaRequest('lists.add_member', $args);
	return $result;
    }
*/
/**
 * Метод исключает e-mail или телефон подписчика из одного или нескольких списков
 * @param <type> $email
 * @param <type> $list Перечисленные через запятую коды списков, из которых мы исключаем подписчика
 * @return <type>
 */
/*
    public function exclude($email, $list) {
		$args = array (
		  'contact_type' => 'email',
		  'contact' => $email
		);
		if ($list)
		    $args['list_ids']=$list;
		return $this->dashaRequest('lists.delete_member', $args);
    }
*/
    public function importContacts($users, $email_list_ids) {
		$args=array('list_id'=>$email_list_ids, 'batch'=>'', 'no_check'=>1);
		$i=0;
		$inserted=0;
		foreach ($users as $user){
			if ($i>=1000){
				$result=$this->dashaRequest('lists.add_member_batch', $args);
				$args=array('list_id'=>$email_list_ids, 'batch'=>'', 'no_check'=>1);
				$i=0;
				//$ids = explode(',', $result->member_ids);
				//$inserted+=count($ids);
			}
			if ($user['newsletter']) {$status = 'пользователь';} else {$status = 'подписчик';}
			$args['batch'] .= $user['email'].','.$user['firstname'].','.$user['lastname'].','.$status.';';
			$i++;
		}
		$result=$this->dashaRequest('lists.add_member_batch', $args);
		//$ids = explode(',', $result->member_ids);
		//$inserted+=count($ids);

		return array('inserted'=>'Запрос успешно отправлен');
    }

    public function getLists() {
		$args = array (
		);
		return $this->dashaRequest('lists.get', $args);
    }

}
