<?php
include(dirname(__FILE__).'/dashaApi.php');

class dashamail extends Module
{
	private $_html = '';
	public function __construct()
	{

		$this->name = 'dashamail';
		$this->tab = 'advertising_marketing';
		$this->version = '0.1';
		$this->author = 'Dashamail';
 
		parent::__construct();

		$this->displayName = $this->l('Рассылка dashamail');
		$this->description = $this->l('Рассылка dashamail');
	}

	public function getContent()
	{
		$this->_postProcess();
		$this->_displayForm();
		return $this->_html;
	}

	private function _displayForm()
	{
		$dashamail_username=Tools::getValue('dashamail_username', Configuration::get('dashamail_username'));
		$dashamail_password=Tools::getValue('dashamail_password', Configuration::get('dashamail_password'));

		$this->_html .='
		<fieldset style="width: 300px;float:right;margin-left:15px;">
			<legend><img src="../img/admin/manufacturers.gif" /> ' . $this->l('Информация') . '</legend>
			<div id="dev_div">
				<span><b>' . $this->l('Версия') . ':</b> ' . $this->version . '</span><br>
				<span><b>' . $this->l('Лицензия') . ':</b> <a class="link" href="http://www.opensource.org/licenses/osl-3.0.php" target="_blank">OSL 3.0</a></span><br>
				<span><b>' . $this->l('Разработчик') . ':</b> <a class="link" href="mailto:support@dashamail.ru" target="_blank">Dashamail</a></span><br>
		                <span><b>' . $this->l('Описание') . ':</b> <a class="link" href="http://dashamail.ru/" target="_blank">Dashamail.ru</a></span><br>
			</div>
		</fieldset>
		<form action="'.$_SERVER['REQUEST_URI'].'" method="post">
			<fieldset>
				<legend>'.$this->l('Ваш аккаунт в Dashamail').'</legend>
					<label for="dashamail_username">'.$this->l('логин').'</label>
					<div class="margin-form">
						<input type="text" name="dashamail_username" value="'.$dashamail_username.'" />
						<p class="clear">'.$this->l('логин').'</p>
					</div>
					<label for="dashamail_password">'.$this->l('пароль').'</label>
					<div class="margin-form">
						<input type="text" name="dashamail_password" value="'.$dashamail_password.'" />
						<p class="clear">'.$this->l('пароль').'</p>
					</div>
					<p class="center">
						<input class="button" type="submit" name="submitdashamailapi" value="'.$this->l('Сохранить').'"/>
					</p>
				</fieldset>
			</form>
		';

		if($dashamail_username && $dashamail_password){
			$this->_html .='
			<form action="'.$_SERVER['REQUEST_URI'].'" method="post">
				<fieldset>
					<legend>'.$this->l('Список рассылки').'</legend>
						<label for="dashamail_list">'.$this->l('Список рассылки').'</label>
						<div class="margin-form">
							<select name="dashamail_list">';

			$dashaApi= new dashaApi($dashamail_username, $dashamail_password);
			$server_lists=$dashaApi->getLists();
			foreach ($server_lists as $server_list)
				$this->_html .='<option value="'.$server_list->id.'"'.($server_list->id==Tools::getValue('dashamail_list', Configuration::get('dashamail_list'))?' selected="selected"':'').'>'.$server_list->name.'</option>';
			
			$this->_html .='</select>
							<p class="clear">'.$this->l('Выберите список рассылки').'</p>
						</div>
						<label for="dashamail_newsletter">'.$this->l('Выгружать всех').'</label>
						<div class="margin-form">
							<input type="checkbox" name="dashamail_newsletter"'.(Tools::getValue('dashamail_newsletter', Configuration::get('dashamail_newsletter'))?' checked="checked"':'').' value="1" />
							<p class="clear">'.$this->l('Иначе выгружаются только подписчики.').'</p>
						</div>
						<p class="center">
							<input class="button" type="submit" name="submitdashamailgen" value="'.$this->l('Отправить').'"/>
						</p>
					</fieldset>
				</form>
			';
		}
	}

	private function _postProcess()
	{
		if(Tools::isSubmit('submitdashamailapi'))
		{
			Configuration::updateValue('dashamail_username', Tools::getValue('dashamail_username'));
			Configuration::updateValue('dashamail_password', Tools::getValue('dashamail_password'));
			$this->_html .= $this->displayConfirmation($this->l('Настройки обновлены.'));
		}elseif(Tools::isSubmit('submitdashamailgen'))
		{
			$dashamail_list=Tools::getValue('dashamail_list');
			$dashamail_newsletter=Tools::getValue('dashamail_newsletter');
			Configuration::updateValue('dashamail_list', $dashamail_list);
			Configuration::updateValue('dashamail_newsletter', $dashamail_newsletter);

			$newsletters=self::getNewsletteremails(!$dashamail_newsletter);
			$dashaApi= new dashaApi(Configuration::get('dashamail_username'), Configuration::get('dashamail_password'));
			$result=$dashaApi->importContacts($newsletters, $dashamail_list);
			$this->_html .= $this->displayConfirmation($result['inserted']);
		}
	}

	private static function getNewsletteremails($is_newsletter=true)
	{
		return Db::getInstance(_PS_USE_SQL_SLAVE_)->ExecuteS('
		SELECT c.`id_customer`, c.`email`, c.`firstname`, c.`lastname`, c.`newsletter`, c.`ip_registration_newsletter`, c.`newsletter_date_add`
		FROM `'._DB_PREFIX_.'customer` c
		WHERE '.($is_newsletter?'c.`newsletter` = 1 AND ':'').'c.`active` = 1
		GROUP BY c.`id_customer`');
	}
}
